/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2020 All Rights Reserved.
 */
package com.abssqr.plat.common.model.convertor.web;

import com.abssqr.plat.common.facade.enums.AstPackStatusEnum;
import com.abssqr.plat.common.facade.enums.AstPackTypeEnum;
import com.abssqr.plat.common.facade.enums.AstScRuleLeftCondEnum;
import com.abssqr.plat.common.facade.enums.AstScRuleRightCondEnum;
import com.abssqr.plat.common.facade.enums.AstScreenRelTypeEnum;
import com.abssqr.plat.common.facade.enums.AstScreenRuleTypeEnum;
import com.abssqr.plat.common.facade.enums.AstTypeEnum;
import com.abssqr.plat.common.facade.model.rule.AstScreenRule;
import com.abssqr.plat.common.facade.param.ast.AstPackOprParam;
import com.abssqr.plat.common.model.domain.ast.AstPack;

import org.activiti.editor.language.json.converter.util.CollectionUtils;
import org.apache.commons.lang3.StringUtils;

/**
 *
 * @author bangis.wangdf
 * @version com.abssqr.plat.common.model.convertor.web: AstPackParamConvert.java, v 0.1 2020-04-21 11:27 bangis.wangdf Exp $ 
 */
public class AstPackParamConvert {
    public static AstPack param2Model(AstPackOprParam param){
        AstPack result = new AstPack();

        result.setPackNo(param.getPackNo());
        result.setPackName(param.getPackName());
        result.setAvalAmt(param.getAvalAmtMoney());
        result.setAstPoolNo(param.getAstPoolNo());
        result.setPackType(AstPackTypeEnum.NORMAL);
        result.setStatus(AstPackStatusEnum.INIT);
        result.setAstType(AstTypeEnum.getByCode(param.getAstType()));
        if (CollectionUtils.isNotEmpty(param.getScreenRuleList())) {
            param.getScreenRuleList().forEach(item -> {
                if (StringUtils.isNotEmpty(item.getLeftValue()) || StringUtils.isNotEmpty(item.getRightValue())) {
                    AstScreenRule rule = new AstScreenRule();
                    result.getScreenRuleList().add(rule);
                    //relNo 关联编号
                    rule.setRelNo(param.getPackNo());
                    //relType 关联类型 1.资产打包 PACK,2数据仓库 DW
                    rule.setRelType(AstScreenRelTypeEnum.PACK);
                    //ruleType 规则类型
                    rule.setRuleType(AstScreenRuleTypeEnum.getByCode(item.getRuleType()));
                    //leftValue 左值
                    rule.setLeftValue(item.getLeftValue());
                    //rightValue 右值
                    rule.setRightValue(item.getRightValue());
                    //leftCondition 左条件: 1.大于 GT 2.大于等于 GE
                    rule.setLeftCondition(AstScRuleLeftCondEnum.getByCode(item.getLeftCondition()));
                    //rightCondition 右条件: 1.小于 LT 2.小于等于 LE 3.等于 EQ 4.包含 IN
                    rule.setRightCondition(AstScRuleRightCondEnum.getByCode(item.getRightCondition()));
                }
            });
        }
        return result;
    }
}
